/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	WBT教材個別ログ　AiccObjectivesテーブルアクセスクラス
//			変更履歴
//				2004.01.08	新規作成	二條智文
//
package jp.co.ntt.lms.lo.WBT.Aicc;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Hashtable;
import java.util.Vector;

import jp.co.ntt.lms.xmo.DataAccess;
import jp.co.ntt.lms.xmo.util.ChangeEncode;
import jp.co.ntt.lms.xmo.util.XMODate;

/**
 * WBT教材個別ログ　AiccObjectivesテーブルアクセスクラスです。<BR>
 * @version 0.0.0.1 2004.01.08
 * @author T.Nijou
 */
public class AiccObjectivesDataAccess 
	extends AiccDataAccess implements AiccConst {

	public static final String TABLE_NAME = "AiccObjectives";
	/**
	 * コンストラクタ
	 **/
	public AiccObjectivesDataAccess() {
		super( TABLE_NAME );
	}

	/**
	 * WBT教材個別ログ　AiccObjectivesテーブルへ登録処理を行います
	 * @param objRecords AiccObjectivesレコード配列
	 * @param objDataAccess データアクセスオブジェクト
	 * @exception SQLException DB操作に失敗した場合
	 */
	public synchronized void insert(	AiccObjectivesRecord[] objRecords,
										DataAccess objDataAccess  )
		throws SQLException
	{
		for( int i = 0; i < objRecords.length; i++ ) {
			// データ変換処理
			Hashtable htbData = changeData( objRecords[i] );
			insertAction( htbData, objDataAccess );
		}
	}

	/**
	 * WBT教材個別ログ　AiccObjectivesテーブルへ登録処理を行います
	 * @param objRecords AiccObjectivesレコードオブジェクト
	 * @param objDataAccess データアクセスオブジェクト
	 * @exception SQLException DB操作に失敗した場合
	 */
	public synchronized void insert(	AiccObjectivesRecord objRecord,
										DataAccess objDataAccess  )
		throws SQLException
	{

		// データ変換処理
		Hashtable htbData = changeData( objRecord );
		insertAction( htbData, objDataAccess );
	}

	/**
	 * WBT教材個別ログ　AiccObjectivesテーブルへ登録処理を行います
	 * @param htbData パラメータ
	 * @exception SQLException DBエラー
	 */
	private void insertAction( Hashtable htbParam, DataAccess objDataAccess )
		throws SQLException
	{

		// 登録用SQLを生成します
		String strSQL = objDataAccess.getInsertSQL( htbParam, TABLE_NAME );

		// 登録処理を実行
		objDataAccess.execute( strSQL );
	}

	/**
	 * WBT教材個別ログ　AiccObjectivesテーブルへ更新処理を行います
	 * @param objRecord 検索データを設定します
	 * @param strUserID ユーザIDを更新条件に設定します
	 * @param strLoID LOID LOIDを更新条件に設定します
	 * @param strSessionID セッションID セッションIDを更新条件に設定します
	 * @param objDataAccess データアクセスオブジェクト
	 * @exception SQLException DB操作に失敗した場合
	 */
	public synchronized void update(	AiccObjectivesRecord objRecord,
										String strUserID,
										String strLoID,
										String strSessionID,
										DataAccess objDataAccess  )
		throws SQLException
	{

		// データ変換処理
		Hashtable htbData = changeData( objRecord );

		String strCondition = AiccMakeCondition.makeCondition(	strUserID,
																strLoID,
																strSessionID );
		updateAction( htbData, strCondition, objDataAccess );
	}

	/**
	 * WBT教材個別ログ　AiccObjectivesテーブルへ更新処理を行います<BR>
	 * @param objRecord 検索データを設定します
	 * @param strCondition 検索条件を設定します
	 * @param objDataAccess データアクセスオブジェクト
	 * @exception SQLException DB操作に失敗した場合
	 */
	public synchronized void update(	AiccObjectivesRecord objRecord,
										String strCondition,
										DataAccess objDataAccess  )
		throws SQLException
	{

		// データ変換処理
		Hashtable htbData = changeData( objRecord );
		updateAction( htbData, strCondition, objDataAccess );
	}

	/**
	 * WBT教材個別ログ　AiccObjectivesテーブルへ更新処理を行います
	 * @param strCondition 更新条件文
	 * @param objDataAccess データアクセスオブジェクト
	 * @exception SQLException DBエラー
	 */
	private void updateAction(	Hashtable htbParam,
								String strCondition,
								DataAccess objDataAccess )
		throws SQLException
	{

		// 登録用SQLを生成します
		String strSQL = objDataAccess.getUpdateSQL( htbParam, TABLE_NAME );

		// SQL連結
		if( strCondition != null ) {
			strSQL = strSQL + strCondition;
		}

		// 更新処理を実行
		objDataAccess.execute( strSQL );
	}

	/**
	 * WBT教材個別ログ　AiccObjectivesテーブルへ削除を行います
	 * @param strUserID ユーザIDを削除条件に設定します
	 * @param strLoID LOID LOIDを削除条件に設定します
	 * @param strSessionID セッションID セッションIDを削除条件に設定します
	 * @param objDataAccess データアクセスオブジェクト
	 * @exception SQLException DB操作に失敗した場合
	 */
	public synchronized void delete(	String strUserID,
										String strLoID,
										String strSessionID,
										DataAccess objDataAccess  )
		throws SQLException
	{
		String strCondition = AiccMakeCondition.makeCondition(	strUserID,
																strLoID,
																strSessionID );
		// 削除処理
		deleteAction( strCondition, objDataAccess );
	}

	/**
	 * WBT教材個別ログ　AiccObjectivesテーブルへ削除を行います
	 * @param strCondition 削除条件文
	 * @param objDataAccess データアクセスオブジェクト
	 * @exception SQLException DB操作に失敗した場合
	 */
	public synchronized void delete(	String strCondition,
										DataAccess objDataAccess  )
		throws SQLException
	{
		// 削除処理
		deleteAction( strCondition, objDataAccess );
	}

	/**
	 * WBT教材個別ログ　AiccObjectivesテーブルへ削除を行います
	 * @param strCondition 削除条件文
	 * @param objDataAccess パラメータ
	 * @exception SQLException DBエラー
	 */
	private void deleteAction( String strCondition, DataAccess objDataAccess )
		throws SQLException
	{

		// 削除用SQLを生成します
		if( strCondition == null ) {
			strCondition = "";
		}
		String strSQL = "DELETE FROM " + TABLE_NAME + strCondition;

		// 削除処理を実行
		objDataAccess.execute( strSQL );
	}


	/**
	 * WBT教材個別ログ　AiccObjectivesテーブルからデータを取得します
	 * @param strUserID ユーザIDを検索条件に設定します
	 * @param strLoID LOID LOIDを検索条件に設定します
	 * @param strSessionID セッションID セッションIDを検索条件に設定します
	 * @param objDataAccess データアクセスオブジェクト
	 * @return AiccObjectivesRecord[] 検索結果の配列
	 * @exception SQLException データベースエラー
	 */
	public AiccObjectivesRecord[] getData(	String strUserID,
											String strLoID,
											String strSessionID,
											DataAccess objDataAccess )
		throws SQLException
	{
		String strCondition = AiccMakeCondition.makeCondition(	strUserID,
																strLoID,
																strSessionID );

		return getData( strCondition, objDataAccess );
	}

	/**
	 * WBT教材個別ログ　AiccObjectivesテーブルからデータを取得します
	 * @param strCondition 検索条件文
	 * @param objDataAccess データアクセスオブジェクト
	 * @return AiccObjectivesRecord[] 検索結果の配列
	 * @exception SQLException データベースエラー
	 */
	public AiccObjectivesRecord[] getData( String strCondition, DataAccess objDataAccess )
		throws SQLException
	{
		AiccObjectivesRecord[] objResult = null;

		if( strCondition == null ) {
			strCondition = "";
		}

		// 検索SQLの組み立て
		String strSQL = "SELECT * FROM " + TABLE_NAME + strCondition;

		ResultSet rs = objDataAccess.executeQuery(strSQL);
		Vector vecResult = new Vector();

		while( rs.next() ) {
			AiccObjectivesRecord objData = new AiccObjectivesRecord();

			objData.setCourseID( ChangeEncode.setChar(rs.getString( COURSE_ID )) );
			objData.setStudentID( ChangeEncode.setChar(rs.getString( STUDENT_ID )) );
			objData.setLessonID( ChangeEncode.setChar(rs.getString( LESSON_ID )) );
			objData.setDate(  XMODate.parseYYYYMMDD( rs.getTimestamp( DATE ) ) );
			objData.setTime( ChangeEncode.setChar(rs.getString( TIME )) );

			objData.setObjectiveID( ChangeEncode.setChar( rs.getString( OBJECTIVE_ID )) );
			objData.setRawScore( ChangeEncode.setChar(rs.getString( RAW_SCORE )) );
			objData.setMaxScore( ChangeEncode.setChar(rs.getString( MAX_SCORE )) );
			objData.setMinScore( ChangeEncode.setChar(rs.getString( MIN_SCORE )) );
			objData.setStatus( ChangeEncode.setChar(rs.getString( STATUS )) );
			objData.setMasteryTime( ChangeEncode.setChar(rs.getString( MASTERY_TIME )) );

			objData.setUserID( ChangeEncode.setChar(rs.getString( USERID )) );
			objData.setLoID( ChangeEncode.setChar(rs.getString( LOID )) );
			objData.setSessionID( ChangeEncode.setChar(rs.getString( SESSIONID )) );
			objData.setUid( ChangeEncode.setChar(rs.getString( UID )) );

			// 結果格納用Vectorに格納
			vecResult.add( objData );
		}

		// 配列に変換
		objResult = new AiccObjectivesRecord[vecResult.size()];
		vecResult.copyInto( objResult );

		return objResult;
	}

	/**
	 * 登録、更新処理時のデータを組み立てます
	 * @param htData
	 * @return Hashtable
	 */
	private Hashtable changeData( AiccObjectivesRecord objRecord ) {
		Hashtable htbData = new Hashtable();
		putData( htbData, COURSE_ID, objRecord.getCourseID() );
		putData( htbData, STUDENT_ID, objRecord.getStudentID() );
		putData( htbData, LESSON_ID, objRecord.getLessonID() );
		putData( htbData, DATE, objRecord.getDate() );
		putData( htbData, TIME, objRecord.getTime() );

		putData( htbData, OBJECTIVE_ID, objRecord.getObjectiveID() );
		putData( htbData, RAW_SCORE, objRecord.getRawScore() );
		putData( htbData, MAX_SCORE, objRecord.getMaxScore() );
		putData( htbData, MIN_SCORE, objRecord.getMinScore() );
		putData( htbData, STATUS, objRecord.getStatus() );
		putData( htbData, MASTERY_TIME, objRecord.getMasteryTime() );

		putData( htbData, USERID, objRecord.getUserID() );
		putData( htbData, LOID, objRecord.getLoID() );
		putData( htbData, SESSIONID, objRecord.getSessionID() );
		putData( htbData, UID, objRecord.getUid() );
		return htbData;
	}

	/**
	 * 安全にHashtableに追加するメソッドです
	 */
	private void putData( Hashtable htbData, String strKey, String strValue ) {
		if( strValue != null && !strValue.equals( "" ) ) {
			htbData.put( strKey, strValue );
		}
	}

}